#!/usr/bin/env python

import wave, struct, math
SAMPLE_RATE = 44100 

def fexp(v):
	negative = v < 0
	v = abs(v)
	v = (math.exp(v) - 1.0) / (math.exp(1.0) - 1.0)
	if negative:
		v *= -1
	return v

def fexp2(v):
	v = math.exp(v + 1)
	v -= math.exp(0)
	v /= (math.exp(2) - math.exp(0))
	v *= 2 #  0 .. 2
	v -= 1 # -1 .. 1
	return v

def fsigm(v):
	v = 4 * v
	v = 1.0 / (1.0 + math.exp(-v))
	v *= 2
	v -= 1
	return v

original = wave.open("dalva.wav", "r")
distorted = []
results = []

for s in ["exp", "exp2", "sigm"]:
	d = wave.open("dalva_%s.wav" % s, "w")
	d.setnchannels(1)
	d.setsampwidth(2)
	d.setframerate(SAMPLE_RATE)
	distorted.append(d)
	results.append([])

n = original.getnframes()
original = struct.unpack('%dh' % n, original.readframes(n))
original = [s / 2.0**15 for s in original]

for i in range(0, len(original)):
	o = original[i]
	exp = fexp(o)
	exp2 = fexp2(o)
	sigm = fsigm(o)
	results[0].append(exp)
	results[1].append(exp2)
	results[2].append(sigm)

results = [ [ sample * 2.0**15 for sample in result ] for result in results ]
for i in range(0, len(results)):
	result = results[i]
	d = distorted[i]
	d.writeframes(struct.pack('%dh' % len(result), *result))


